Subject: Re: CONFIG_PROVE_LOCKING broken on 83xx (and all of powerpc?)

From: Benjamin Herrenschmidt <[email-masked]>
Date: Fri, 10 Sep 2010 08:01:01 +1000

On Thu, 2010-09-09 at 12:36 -0700, Ira W. Snyder wrote:
> On Thu, Sep 09, 2010 at 02:10:59PM -0500, Timur Tabi wrote:
> > On Thu, Sep 9, 2010 at 1:44 PM, Ira W. Snyder <[email-masked]> wrote:
> > 
> > > Single stepping through the initial assembly portion of kernel startup
> > > shows that the FDT gets clobbered during the function early_init(). This
> > > trace is reproduced below.
> > 
> > Have you tried also enabling CONFIG_DEBUG_LOCK_ALLOC?  These two
> > config options are related.
> > 
> 
> Yes, I have had it enabled the whole time.
> 
> As noted in another email, it appears that U-Boot puts the FDT in such a
> place that Linux overwrites it with the BSS. The CONFIG_PROVE_LOCKING=y
> option expands the BSS by a large amount, which causes the error. It
> isn't directly lockdep related.
> 
> I don't know if this is a U-Boot problem or a Linux problem. I have no
> idea how to fix the bug.

Definitely a u-boot problem. There must be a way to set where the fdt
goes somewhere.

Cheers,
Ben.